---not edit script---

guiSetGet = {};

function guiSetGet:loadMenueImages(self)
	local iconFilePath = guiSetGet:checkDesignFilePath();
	if iconFilePath == nil then return;end;	
	local overlay = g_currentMission.guiMenue.overlays;
	overlay["guiGroundT"] = Overlay:new('guiGroundT', iconFilePath, g_currentMission.guiMenue.default.posX-(g_currentMission.guiMenue.default.width/2), g_currentMission.guiMenue.default.posY-(g_currentMission.guiMenue.default.height), g_currentMission.guiMenue.default.width, g_currentMission.guiMenue.default.height);
	guiSetGet:setOverlayUVsPx(overlay["guiGroundT"], guiSetGet.icon["guiGroundT"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	guiSetGet:setBackgroundColor(overlay["guiGroundT"], g_currentMission.guiMenue.default.groundColor);
	overlay["guiLineT"] = Overlay:new('guiLineT', iconFilePath, g_currentMission.guiMenue.default.posX-(g_currentMission.guiMenue.default.width/2), g_currentMission.guiMenue.default.posY-g_currentMission.guiMenue.default.iconHeight, g_currentMission.guiMenue.default.width, 0.001);
	guiSetGet:setOverlayUVsPx(overlay["guiLineT"], guiSetGet.icon["guiLineT"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["guiSettings"] = Overlay:new('guiSettings', iconFilePath, g_currentMission.guiMenue.default.posX-(g_currentMission.guiMenue.default.width/2), g_currentMission.guiMenue.default.posY-g_currentMission.guiMenue.default.iconHeight, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["guiSettings"], guiSetGet.icon["settings"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["helpGround"] = Overlay:new('helpGround', iconFilePath, 0, 0, 0, 0);
	guiSetGet:setOverlayUVsPx(overlay["helpGround"], guiSetGet.icon["guiGround"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	guiSetGet:setBackgroundColor(overlay["helpGround"], g_currentMission.guiMenue.default.helpGroundColor);
	overlay["buttonGround"] = Overlay:new('buttonGround', iconFilePath, 0, 0, 0, 0);
	guiSetGet:setOverlayUVsPx(overlay["buttonGround"], guiSetGet.icon["guiGround"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["buttonGroundT"] = Overlay:new('buttonGroundT', iconFilePath, 0, 0, 0, 0);	
	guiSetGet:setOverlayUVsPx(overlay["buttonGroundT"], guiSetGet.icon["guiGroundT"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	guiSetGet:setBackgroundColor(overlay["buttonGroundT"], g_currentMission.guiMenue.default.buttonGroundColor);
	overlay["roundRight"] = Overlay:new('roundRight', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["roundRight"], guiSetGet.icon["roundRight"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["roundLeft"] = Overlay:new('roundLeft', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["roundLeft"], guiSetGet.icon["roundLeft"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["roundMultiple"] = Overlay:new('roundMultiple', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["roundMultiple"], guiSetGet.icon["roundMultiple"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["halfRoundRight"] = Overlay:new('halfRoundRight', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["halfRoundRight"], guiSetGet.icon["halfRoundRight"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["halfRoundLeft"] = Overlay:new('halfRoundLeft', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["halfRoundLeft"], guiSetGet.icon["halfRoundLeft"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["arrowRight"] = Overlay:new('arrowRight', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["arrowRight"], guiSetGet.icon["arrowRight"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["arrowLeft"] = Overlay:new('arrowLeft', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["arrowLeft"], guiSetGet.icon["arrowLeft"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["okay"] = Overlay:new('okay', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["okay"], guiSetGet.icon["okay"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["notOkay"] = Overlay:new('notOkay', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["notOkay"], guiSetGet.icon["notOkay"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["notReady"] = Overlay:new('notReady', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["notReady"], guiSetGet.icon["notReady"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["infoText"] = Overlay:new('infoText', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["infoText"], guiSetGet.icon["infoText"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["roundButton"] = Overlay:new('roundButton', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["roundButton"], guiSetGet.icon["roundButton"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["saveButton"] = Overlay:new('saveButton', iconFilePath, g_currentMission.guiMenue.default.posX+(g_currentMission.guiMenue.default.width/2)-g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.posY-g_currentMission.guiMenue.default.iconHeight, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["saveButton"], guiSetGet.icon["saveButton"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);	
	overlay["arrowDown"] = Overlay:new('arrowDown', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["arrowDown"], guiSetGet.icon["arrowDown"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
	overlay["arrowUp"] = Overlay:new('arrowUp', iconFilePath, 0, 0, g_currentMission.guiMenue.default.iconWidth, g_currentMission.guiMenue.default.iconHeight);
	guiSetGet:setOverlayUVsPx(overlay["arrowUp"], guiSetGet.icon["arrowUp"], guiSetGet.iconSize.m6x32[1], guiSetGet.iconSize.m6x32[2]);
end;

function guiSetGet:deleteMenueImages()
	if #g_currentMission.guiMenue.overlays > 0 then
		for a=1, #g_currentMission.guiMenue.overlays do
			guiSetGet:deleteOldOverlay(g_currentMission.guiMenue.overlays[a]);
		end;
	end;
end;

function guiSetGet:defaultValues(self)	
	g_currentMission.guiMenue.default = {
		buttonGfxWidth1 = guiSetGet:pxToNormal(1, 'x');
		buttonGfxHeight1  = guiSetGet:pxToNormal(1, 'y');
		posX = 0.5;
		posY = 0.9;
		iconHeight = guiSetGet:pxToNormal(1, 'Y')*30;
		iconWidth = guiSetGet:pxToNormal(1, 'x')*31;
		width = guiSetGet:pxToNormal(1, 'x')*800;
		height = guiSetGet:pxToNormal(1, 'y')*800;
		textColor = guiSetGet.colors["white"];
		textWarningColor = guiSetGet.colors["red"];
		groundColor = guiSetGet.colors["black"];
		buttonGroundColor = guiSetGet.colors["grayInactive"];
		groundLineColor = guiSetGet.colors["white"];
		markerColor = guiSetGet.colors["yellow"];
		helpTextColor = guiSetGet.colors["black"];
		helpGroundColor = guiSetGet.colors["ls15"];
		infoTextColor = guiSetGet.colors["yellow"];
		infoTextSize = 0.009;
		helpTextSize = 0.009;
		size = 0.010;
		buttonsTypes = {
			type0 = "hidden",
			type1 = "arrowLeft",
			type2 = "arrowLeftDouble",
			type3 = "arrowRight",
			type4 = "arrowRightDouble",
			type5 = "arrowDown",			
			type6 = "arrowDownDouble",
			type7 = "arrowUp",			
			type8 = "arrowUpDouble",
			type9 = "roundRight",
			type10 = "roundRightDouble",
			type11 = "roundLeft",
			type12 = "roundLeftDouble",
			type13 = "halfRoundRight",
			type14 = "halfRoundRightDouble",
			type15 = "halfRoundLeft",
			type16 = "halfRoundLeftDouble",
			type17 = "roundMultiple",
			type18 = "roundMultipleDouble",
			type19 = "roundButton",
			type20 = "roundButtonDouble"
		};	
	};
	guiSetGet.iconSize = {
		m1x128   		= { 512, 2048 }; --Orginal Bildgröße x128
		m4x64   		= { 256, 2048 }; --x16
		m6x32   		= { 128, 256 }; --x8
		ls256   		= { 256, 256 }; --x8
		zoomToleranz	= { 0.005, 0.01 }; --zoom Toleranz
	};
	guiSetGet.icon = {		
		guiGroundT   	= { 0+0.1, 128*2-0.1, 32-0.1, 128+96+0.1};		
		guiLineT     	= { 0+0.1, 128*2-0.1, 8-0.1, 128+112+0.1};
		guiGround    	= { 32+1, 128*2-1, 64-1, 128+96+1};
		guiLine      	= { 8+0.1, 128*2-0.1, 16-0.1, 128+112+0.1};		
		
		settings   	   	= { 0+0.1, 128*1-0.1-96, 32-0.1, 0+0.1};
		roundRight     	= { 32+0.1, 128*1-0.1-96, 64-0.1, 0+0.1};
		roundMultiple 	= { 64+0.1, 128*1-0.1-96, 96-0.1, 0+0.1};
		roundLeft      	= { 96+0.1, 128*1-0.1-96, 128-0.1, 0+0.1};
		
		halfRoundLeft  	= { 0+0.1, 128*1-0.1-64, 32-0.1, 0+32+0.1};
		halfRoundRight 	= { 32+0.1, 128*1-0.1-64, 64-0.1, 0+32+0.1};
		arrowLeft      	= { 64+0.1, 128*1-0.1-64, 96-0.1, 0+32+0.1};
		arrowRight     	= { 96+0.1, 128*1-0.1-64, 128-0.1, 0+32+0.1};
		
		okay           	= { 0+0.1, 128*1-0.1-32, 32-0.1, 0+64+0.1};
		notOkay        	= { 32+0.1, 128*1-0.1-32, 64-0.1, 0+64+0.1};
		notReady       	= { 64+0.1, 128*1-0.1-32, 96-0.1, 0+64+0.1};
		saveButton		= { 96+0.1, 128*1-0.1-32, 128-0.1, 0+64+0.1};
		
		infoText       	= { 0+0.1, 128*1-0.1, 32-0.1, 0+96+0.1};
		roundButton		= { 32+0.1, 128*1-0.1, 64-0.1, 0+96+0.1};
		arrowUp		    = { 64+0.1, 128*1-0.1, 96-0.1, 0+96+0.1};
		arrowDown		= { 96+0.1, 128*1-0.1, 128-0.1, 0+96+0.1};		
	};
	guiSetGet:loadMenueImages(self);
end;

function guiSetGet:generateModMenue(modMenueName, settingsName, modVersion)
	if g_currentMission.guiMenue.mod[tostring(modMenueName)] ~= nil then 
		print(tostring(g_currentMission.guiMenue.master.metadata.title).. " Error !!! \nmodMenueName(".. tostring(modMenueName).. ")already --guiSetGet:generateModMenue(modMenueName, settingsName)--");
	else
		g_currentMission.guiMenue.modMenueTable[#g_currentMission.guiMenue.modMenueTable+1] = tostring(modMenueName);
		g_currentMission.guiMenue.mod[tostring(modMenueName)] = {};
		g_currentMission.guiMenue.mod[tostring(modMenueName)].modVersion = Utils.getNoNil(tostring(modVersion), "");
		g_currentMission.guiMenue.mod[tostring(modMenueName)].settingsName = tostring(settingsName);
		g_currentMission.guiMenue.mod[tostring(modMenueName)].lastPage = 1;
		g_currentMission.guiMenue.mod[tostring(modMenueName)].page = {};
		g_currentMission.guiMenue.mod[tostring(modMenueName)].save = false;
		g_currentMission.guiMenue.mod[tostring(modMenueName)].tempSave = false;		
	end;
end;

function guiSetGet:generateModMenuePage(modMenueName, pageName, page, size, optiAutoSize, infoSize, helpSize, txtBold)
	if g_currentMission.guiMenue.mod[tostring(modMenueName)] == nil then 
		print(tostring(g_currentMission.guiMenue.master.metadata.title).. " Error !!! \nGenerate first: --> guiSetGet:generateModMenue(modMenueName, settingsName) <-- not found !!!");
	else
		g_currentMission.guiMenue.mod[tostring(modMenueName)].page[page] = {
			pageName=tostring(pageName);
			pageNumber = tonumber(page);
			openDownUpText = false;
			openDownUpLine = 0;
			returnClick = {line=0,button=0,buttonDouble=0,openDownUpLine=0}; --line 1 2 3 etc., button 1 2 3 etc., buttonDouble 1(left) 2(right) !double function ignore value! !is not value 0 then set your command and reset values {line=0,button=0,buttonDouble=0,openDownUpLine=0}
			size=Utils.getNoNil(tonumber(size), g_currentMission.guiMenue.default.size);
			optiSize=Utils.getNoNil(optiAutoSize, false);
			txtBold=Utils.getNoNil(txtBold, false);
			helpSize = g_currentMission.guiMenue.default.helpTextSize;
			infoSize = g_currentMission.guiMenue.default.infoTextSize;
			buttons = {};			
		};				
		if infoSize ~= nil and type(infoSize) == "number" then g_currentMission.guiMenue.mod[tostring(modMenueName)].page[page].infoSize = tonumber(infoSize);end;
		if helpSize ~= nil and type(helpSize) == "number" then g_currentMission.guiMenue.mod[tostring(modMenueName)].page[page].helpSize = tonumber(helpSize);end;
	end;
end;

function guiSetGet:generateModMenuePageButtonLine(modMenueName, page, line, buttonsTypesAtLine, distanceButtons, distanceLine, buttonsCmdType, buttonsCmdTable, buttonsCmdTableValue, textOverButtons, textOverColor, buttonsHelpText, buttonsInfoText, openDownUpText, openDownUpTextSize)
	if g_currentMission.guiMenue.mod[tostring(modMenueName)] == nil or g_currentMission.guiMenue.mod[tostring(modMenueName)].page[page] == nil then
		print(tostring(g_currentMission.guiMenue.master.metadata.title).. " Error !!! \nGenerate first: --> guiSetGet:generateModMenuePage(modMenueName, pageName, page, size, optiAutoSize, infoSize, helpSize, txtBold) <-- not found page ".. tostring(page).. " !!!");
	else
		local buttons = g_currentMission.guiMenue.mod[tostring(modMenueName)].page[page].buttons;
		buttons[line] = {};		
		buttons[line].overButtonText = false;
		buttons[line].openDownUpText = false;
		for a=1, #buttonsTypesAtLine do			
			buttons[line].maxButtons = a;
			buttons[line][a] = {};
			buttons[line][a].buttonType = Utils.getNoNil(buttonsTypesAtLine[a], "hidden");
			buttons[line][a].helpText = Utils.getNoNil(buttonsHelpText[a], "");
			buttons[line][a].infoText = Utils.getNoNil(buttonsInfoText[a], "");
			buttons[line][a].textOverButton = Utils.getNoNil(textOverButtons[a], "");
			local r, g, b, t = false,false,false,false;
			if textOverColor[a] ~= nil then
				r=Utils.getNoNil(textOverColor[a][1],false);g=Utils.getNoNil(textOverColor[a][2],false);b=Utils.getNoNil(textOverColor[a][3],false);t=Utils.getNoNil(textOverColor[a][4],false);
			end;
			if not r or not g or not b or not t then color = g_currentMission.guiMenue.default.textColor;else color = {r,g,b,t};end;
			buttons[line][a].textOverColor = Utils.getNoNil(color);
			buttons[line][a].buttonCmdType = Utils.getNoNil(buttonsCmdType[a], "unknown"); --boolean,string,stringOnly,money,1. or 1.0 or 0.2 etc. --(string format)			
			buttons[line][a].buttonCmdTable = buttonsCmdTable[a];
			buttons[line][a].buttonCmdTableValue = buttonsCmdTableValue[a];
			buttons[line][a].openDownUpText = openDownUpText[a]; --a table
			buttons[line][a].openDownUpTextSize = g_currentMission.guiMenue.mod[tostring(modMenueName)].page[page].size;
			if openDownUpTextSize ~= nil and openDownUpTextSize[a] ~= nil then buttons[line][a].openDownUpTextSize=Utils.getNoNil(openDownUpTextSize[a], g_currentMission.guiMenue.mod[tostring(modMenueName)].page[page].size);end;
			if string.len(Utils.getNoNil(buttons[line][a].textOverButton, "")) > 0 then buttons[line].overButtonText = true;end;
			--print("buttonCmdValues ...".. tostring(buttons[line][a].buttonCmdValues));
		end;
		buttons[line].distanceLine = Utils.getNoNil(tonumber(distanceLine), 0.015);
		buttons[line].distanceButtons = Utils.getNoNil(tonumber(distanceButtons), 0.005);
	end;
end;

local abs, ceil, floor, max, min, random, pow = math.abs, math.ceil, math.floor, math.max, math.min, math.random, math.pow;
function guiSetGet:round(n, precision)
	if precision and precision > 0 then
		return floor((n * pow(10, precision)) + 0.5) / pow(10, precision);
	end;
	return floor(n + 0.5);
end;

local targetAspectRatio = 16/9;
local aspectRatioRatio = g_screenAspectRatio / targetAspectRatio;
local sizeRatio = 1;
if g_screenWidth >= 1920 then
	sizeRatio = 1920 / g_screenWidth;
elseif g_screenWidth < 1920 then
	sizeRatio = max((1920 / g_screenWidth) * 0.75, 1);
end;

function guiSetGet:getFullPx(n, dimension)
	if dimension == 'x' then
		return guiSetGet:round(n * g_screenWidth) / g_screenWidth;
	else
		return guiSetGet:round(n * g_screenHeight) / g_screenHeight;
	end;
end;

function guiSetGet:pxToNormal(px, dimension, fullPixel)
	local ret;
	if dimension == 'x' then
		ret = (px / 1920) * sizeRatio;
	else
		ret = (px / 1080) * sizeRatio * aspectRatioRatio;
	end;
	if fullPixel == nil or fullPixel then
		ret = guiSetGet:getFullPx(ret, dimension);
	end;
	return ret;
end;

function guiSetGet:setBackgroundColor(overlay, color)
	if overlay.overlayId then
		setOverlayColor(overlay.overlayId, unpack(color));		
	end;
end;

function guiSetGet:setOverlay(overlay, posX, posY, width, height, invertX, rotation, rotationX, rotationY)	
	if overlay ~= nil and overlay.overlayId then
		if width then overlay.width = width;end;
		if height then overlay.height = height;end;
		if posX then overlay.x = posX;end;
		if posY then overlay.y = posY;end;
		if invertX ~= nil and invertX then overlay.invertX = invertX;end;
		if rotation ~= nil and rotation then overlay.rotation = rotation;end;
		if rotationX ~= nil and rotationX then overlay.rotationCenterX = rotationX;end;
		if rotationY ~= nil and rotationY then overlay.rotationCenterY = rotationY;end;
		--overlay:setPosition(posX, posY);end;
	end;
end;

function guiSetGet:getOverlay(overlay)	
	if overlay ~= nil and overlay.overlayId then
		return overlay.x, overlay.y, overlay.width, overlay.height;			
	end;
	return nil;
end;

function guiSetGet:setOverlayUVsPx(overlay, UVs, textureSizeX, textureSizeY)	
	if overlay.overlayId and overlay.currentUVs == nil or overlay.currentUVs ~= UVs then
		local leftX, bottomY, rightX, topY = unpack(UVs);
		local fromTop = false;
		if topY < bottomY then
			fromTop = true;
		end;
		local leftXNormal = leftX / textureSizeX;
		local rightXNormal = rightX / textureSizeX;
		local bottomYNormal = bottomY / textureSizeY;
		local topYNormal = topY / textureSizeY;
		if fromTop then
			bottomYNormal = 1 - bottomYNormal;
			topYNormal = 1 - topYNormal;
		end;
		setOverlayUVs(overlay.overlayId, leftXNormal,bottomYNormal, leftXNormal,topYNormal, rightXNormal,bottomYNormal, rightXNormal,topYNormal);
		overlay.currentUVs = UVs;
	end;
end;

function guiSetGet:deleteOldOverlay(overlay)
	if overlay ~= nil and overlay and overlay.overlayId ~= nil and overlay.overlayId then
		overlay:delete();
		overlay = nil;		
	end;
end;

function guiSetGet:checkDesignFilePath()	
	local iconFilePath = Utils.getFilename("guiMenue/menueDesign.dds", guiMenue.modDir );			
	if not fileExists(iconFilePath) then		
		iconFilePath = nil;				
	end;
	return iconFilePath;
end;

guiSetGet.colors = {		
	darkYellow =   		{ 255/255, 161/255,  17/255, 1.00 };
	darkYellowOff =  	{ 255/255, 161/255,  17/255, 0.80 };
	white =         	{ 255/255, 255/255, 255/255, 1.00 };
	whiteBestPrice =	{ 255/255, 255/255, 255/255, 1.00 };
	whiteInactive = 	{ 255/255, 255/255, 255/255, 0.75 };
	whiteDisabled = 	{ 255/255, 255/255, 255/255, 0.15 };
	hover =         	{   4/255,  98/255, 180/255, 1.00 };
	hoverBestPrice =	{   4/255,  98/255, 180/255, 0.70 };
	darkBlue =	 		{ 	0/255,   0/255, 255/255, 1.00 };
	activeGreen =   	{  43/255, 205/255,  10/255, 1.00 }; 
	activeRed =    	 	{ 153/255,  22/255,  19/255, 1.00 }; 
	closeRed =      	{ 116/255,   0/255,   0/255, 1.00 }; 
	warningRed =    	{ 222/255,   2/255,   3/255, 1.00 };
	red =      			{ 255/255,   0/255,   0/255, 1.00 };
	redDisabled =   	{ 255/255,   0/255,   0/255, 0.80 };
	shadow =        	{   4/255,   4/255,   4/255, 1.00 }; 
	textDark =      	{   1/255,   1/255,   1/255, 1.00 };
	yellow =        	{ 255/255, 255/255,   0/255, 1.00 };
	yellowDisabled =	{ 255/255, 255/255,   0/255, 0.80 };
	yellowGreen =		{ 154/255, 205/255,  50/255, 1.00 };
	yellow1 =			{ 238/255, 221/255, 130/255, 1.00 };
	gold =				{ 255/255, 215/255,   0/255, 1.00 };
	green =        		{ 	0/255, 255/255,   0/255, 1.00 };
	darkOliveGreen =    {  85/255, 107/255,  47/255, 1.00 };
	greenDisabled = 	{ 	0/255, 255/255,   0/255, 0.80 };
	greenMatt		 = 	{ 	0/255, 255/255,   0/255, 0.30 };
	darkGreen = 		{ 	0/255, 100/255,   0/255, 1.00 };
	lightGreen =   		{ 144/255, 238/255, 144/255, 1.00 };
	chartreuse4 =		{ 69/255,  139/255,   0/255, 1.00 };
	happylooser =   	{ 143/255, 188/255, 143/255, 1.00 };---
	happylooserOff= 	{ 143/255, 188/255, 143/255, 0.80 };---
	gray = 				{ 190/255, 190/255, 190/255, 1.00 };
	grayInactive = 		{ 190/255, 190/255, 190/255, 0.50 };
	black =        		{ 	0/255,   0/255,   0/255, 1.00 };
	blackDisabled = 	{ 	0/255, 	 0/255,   0/255, 0.75 };
	blackInactive = 	{ 	0/255, 	 0/255,   0/255, 0.15 };
	orange =        	{ 255/255, 165/255,   0/255, 1.00 };
	orangeRed =        	{ 255/255,  55/255,   0/255, 1.00 };
	khaki =         	{ 240/255, 230/255, 140/255, 1.00 };
	ls15 =          	{   0/255, 255/255, 255/255, 1.00 };
	ls15Disabled =  	{   0/255, 255/255, 255/255, 0.80 };
	mangenta =  		{ 255/255, 	 0/255, 255/255, 1.00 };
	deepPink =  		{ 255/255, 020/255, 147/255, 1.00 };
	purple =  			{ 160/255, 032/255, 240/255, 1.00 };
};