viKeyMouseEvents = {};

function viKeyMouseEvents:setKeyMouse(self, unicode, sym, modifier, isDownKey, posX, posY, isDown, isUp, button)
	if unicode ~= nil then
		if not viGui.settingsOnViMenue.dragDropPos then
			viKeyMouseEvents:setKey(self, unicode, sym, modifier, isDown);			
		end;
	else
		if not viGui.settingsOnViMenue.dragDropPos then
			viKeyMouseEvents:setMouse(self, posX, posY, isDown, isUp, button);
		else
			viKeyMouseEvents:setDragDropMouse(self, posX, posY, isDown, isUp, button);
		end;
	end;
end;

function viKeyMouseEvents:setDragDropMouse(self, posX, posY, isDown, isUp, button)
	if not g_currentMission.vi.isOn or (g_currentMission.guiMenue.on and g_currentMission.guiMenue.modMenue ~= VehicleInspector.modMenue) then return;end;
	viDragDrop:setPosition(self, posX, posY, true, viGui.settingsOnViMenue.dragDropGround.width, viGui.settingsOnViMenue.dragDropGround.height, "settingsOnViMenue");
	if button == Input.MOUSE_BUTTON_LEFT and isDown then		
		if viGui.settingsOnViMenue.clickArea ~= nil and #viGui.settingsOnViMenue.clickArea > 0 then			
			if VehicleInspector:mouseIsInArea(posX, posY, unpack(viGui.settingsOnViMenue.clickArea[1])) then
				if viGui.settingsOnViMenue.dragDropPos and isDown then
					viGui.settingsOnViMenue.dragDropPos = false;
					viDragDrop:setPosition(self, 0, 0, false);
					viMouseClickAreas:setMenueCfg(self);					
				end;
			else
				if viGui.settingsOnViMenue.dragDropPos then
					viGui.settingsOnViMenue.dragDropPos = false;
					viDragDrop:setPosition(self, 0, 0, false);
					viGui.settingsOnViMenue.posX = posX;
					viGui.settingsOnViMenue.posY = posY; --viGui.buttonGfxHeight1*viGui.settingsOnViMenue.zoomOutIn*5;
					viMouseClickAreas:setMenueCfg(self);
					g_currentMission.guiMenue.mod[tostring("VehicleInspector")].tempSave = true;
					return;
				end;
			end;
		end;
	end;
end;

function viKeyMouseEvents:setKey(self, unicode, sym, modifier, isDown)
	if g_currentMission.vi ~= nil then
		if viGui.binding.onOff and InputBinding.isPressed(InputBinding.VI_OnOff) then
			if g_currentMission.vi.isOn then g_currentMission.vi.isOn = false;else g_currentMission.vi.isOn = true;end;
		elseif g_currentMission.vi.isOn and viGui.binding.hiddenOnOff and InputBinding.isPressed(InputBinding.VI_Hidden) then
			if g_currentMission.vi.isHidden then g_currentMission.vi.isHidden = false;else g_currentMission.vi.isHidden = true;end;
		elseif g_currentMission.vi.isOn and viGui.binding.mouseOnOff and InputBinding.isPressed(InputBinding.VI_OnOffMouseCursor) then
			if g_currentMission.vi.foundMoh and g_currentMission.vi.frozenAndCursorOverMoh then	return;end;
			if g_currentMission.vi.isMouseCursor then 
				g_currentMission.vi.isMouseCursor = false;				
				InputBinding.setShowMouseCursor(false);
				if g_currentMission.vi.setFrozen then g_currentMission.vi.isFrozen = false;g_currentMission.isPlayerFrozen = false;end;
			else 
				g_currentMission.vi.isMouseCursor = true;
				InputBinding.setShowMouseCursor(true);
				if g_currentMission.vi.setFrozen then g_currentMission.vi.isFrozen = true;g_currentMission.isPlayerFrozen = true;end;
			end;
		elseif g_currentMission.vi.isOn and not VehicleInspector:getFrozenMouseControlled() and viGui.defaultHud.vehicleSettingsKeySelect.on and not g_currentMission.guiMenue.on then
			local upDisplay = viGui.defaultHud.pos == 4 or viGui.defaultHud.pos == 5 or viGui.defaultHud.pos == 6;
			if (viGui.binding.keySelectAction and viGui.binding.keySelectUp and InputBinding.isPressed(InputBinding.VI_KeySelectUp) and not upDisplay) or 
				(viGui.binding.keySelectAction and viGui.binding.keySelectDown and InputBinding.isPressed(InputBinding.VI_KeySelectDown) and upDisplay) then				
				viGui.defaultHud.vehicleSettingsKeySelect.keyPos = viGui.defaultHud.vehicleSettingsKeySelect.keyPos-1;				
				if viGui.defaultHud.vehicleSettingsKeySelect.keyPos < viGui.settingsOnViMenue.maxSelectKey then 
					if g_currentMission.vi.isHidden and viGui.defaultHud.vehicleSettingsKeySelect.vehicleCounter == 0 then viGui.defaultHud.vehicleSettingsKeySelect.keyPos = 0;else
					viGui.defaultHud.vehicleSettingsKeySelect.keyPos = viGui.defaultHud.vehicleSettingsKeySelect.vehicleCounter;end;
				end;
			elseif (viGui.binding.keySelectAction and viGui.binding.keySelectDown and InputBinding.isPressed(InputBinding.VI_KeySelectDown) and not upDisplay) or 
				(viGui.binding.keySelectAction and viGui.binding.keySelectUp and InputBinding.isPressed(InputBinding.VI_KeySelectUp) and upDisplay) then
				viGui.defaultHud.vehicleSettingsKeySelect.keyPos = viGui.defaultHud.vehicleSettingsKeySelect.keyPos+1;				
				if (not g_currentMission.vi.isHidden and viGui.defaultHud.vehicleSettingsKeySelect.keyPos > viGui.defaultHud.vehicleSettingsKeySelect.vehicleCounter) or g_currentMission.vi.isHidden then 
					if not g_currentMission.vi.isHidden then viGui.defaultHud.vehicleSettingsKeySelect.keyPos = viGui.settingsOnViMenue.maxSelectKey;
					elseif g_currentMission.vi.isHidden and viGui.defaultHud.vehicleSettingsKeySelect.keyPos < viGui.settingsOnViMenue.maxSelectKey then viGui.defaultHud.vehicleSettingsKeySelect.keyPos = viGui.defaultHud.vehicleSettingsKeySelect.vehicleCounter;
					elseif g_currentMission.vi.isHidden and viGui.defaultHud.vehicleSettingsKeySelect.keyPos > viGui.defaultHud.vehicleSettingsKeySelect.vehicleCounter then viGui.defaultHud.vehicleSettingsKeySelect.keyPos = viGui.settingsOnViMenue.maxSelectKey;
					end;
				end;
			elseif (viGui.binding.keySelectUp or viGui.binding.keySelectDown) and viGui.binding.keySelectAction and InputBinding.isPressed(InputBinding.VI_KeySelectAction) then
				if viGui.defaultHud.vehicleSettingsKeySelect.keyPos > 0 and viGui.defaultHud.vehicleSettingsKeySelect.node ~= nil then
					local vehicle = g_currentMission.nodeToVehicle[viGui.defaultHud.vehicleSettingsKeySelect.node];
					if vehicle ~= nil and vehicle.isControlled then
						g_currentMission:showBlinkingWarning("Vehicle is not free", 3500);
						return;
					elseif vehicle ~= nil then
						g_currentMission:requestToEnterVehicle(vehicle);
					end;
				elseif viGui.defaultHud.vehicleSettingsKeySelect.keyPos < 1 then					
					if viGui.defaultHud.vehicleSettingsKeySelect.keyPos == 0 and not viGui.settingsGuiMenue.on then
						viGui.settingsGuiMenue.on = true;			
						g_currentMission.guiMenue.on = true;
						g_currentMission.guiMenue.modMenue = VehicleInspector.modMenue;
						if g_currentMission.vi.foundMoh and g_currentMission.vi.frozenAndCursorOverMoh then												
							g_currentMission.vi.Moh.table.moGeneralSettings.setMouseCursor = true;
							g_currentMission.vi.Moh.table.moGeneralSettings.setFrozen = true;
						else
							g_currentMission.vi.isMouseCursor = true;
							InputBinding.setShowMouseCursor(true);
							if g_currentMission.vi.setFrozen then g_currentMission.vi.isFrozen = true;g_currentMission.isPlayerFrozen = true;end;
						end;
					elseif viGui.defaultHud.vehicleSettingsKeySelect.keyPos == -1 then
						if g_currentMission.vi.isHidden then g_currentMission.vi.isHidden = false;else g_currentMission.vi.isHidden = true;end;
					elseif (viGui.defaultHud.vehicleSettingsKeySelect.keyPos == -2 and viGui.defaultHud.vehicleSettingsKeySelect.keyPos ~= viGui.settingsOnViMenue.taskSelectKey) or
						(viGui.defaultHud.vehicleSettingsKeySelect.keyPos == -2 and not viGui.settingsOnViMenue.isTask) then
						if (viGui.defaultHud.seeGlobalWarningIcon and not g_currentMission.vi.isHidden) or (g_currentMission.vi.isHidden and g_currentMission.vi.hiddenWarnings) then
							if viGui.defaultHud.seeGlobalWarningVehicle then
								g_currentMission.vi.isHidden = viGui.defaultHud.seeGlobalWarningVehicleOldHidden;
								viGui.defaultHud.seeGlobalWarningVehicle = false;
								viGui.defaultHud.seeGlobalWarningVehicleAutoOffIsTimer = 0;				
							else
								viGui.defaultHud.seeGlobalWarningVehicleOldHidden = g_currentMission.vi.isHidden;
								g_currentMission.vi.isHidden = true;				
								viGui.defaultHud.seeGlobalWarningVehicle = true;				
							end;
						end;
					elseif viGui.settingsOnViMenue.isTask and viGui.defaultHud.vehicleSettingsKeySelect.keyPos == viGui.settingsOnViMenue.taskSelectKey then
						if viGui.settingsOnViMenue.isTaskOpen then
							viGui.settingsOnViMenue.isTaskOpen = false;
						else
							viGui.settingsOnViMenue.isTaskOpen = true;
						end;
						if #viGui.settingsOnViMenue.taskClickArea <= 0 then
							g_currentMission:showBlinkingWarning("Not Found Taskbar Icons", 1500);
						end;
					end;				
				end;
			end;
		end;
	end;
end;

function viKeyMouseEvents:setMouse(self, posX, posY, isDown, isUp, button)
	local foundHelpText = false;
	if g_currentMission.vi ~= nil and g_currentMission.vi.isOn then		
		if viGui.settingsOnViMenue.clickArea ~= nil and #viGui.settingsOnViMenue.clickArea > 0 then
			for a=1, table.getn(viGui.settingsOnViMenue.clickArea) do
				if viGui.settingsOnViMenue.clickArea[a] ~= nil then
					if VehicleInspector:mouseIsInArea(posX, posY, unpack(viGui.settingsOnViMenue.clickArea[a])) then
						--g_currentMission:showBlinkingWarning(tostring(viGui.settingsOnViMenue.clickArea[a][6]), 2000);
						if button == Input.MOUSE_BUTTON_LEFT and isDown then
							viKeyMouseEvents:setMouseClick(self, viGui.settingsOnViMenue.clickArea[a][5], posX, posY);
							break;
						else
							viGui.helpText.posX = posX;
							viGui.helpText.posY = posY;
							viGui.helpText.txt = tostring(viGui.settingsOnViMenue.clickArea[a][6]);
							foundHelpText = true;
							break;
						end;					
					end;
				end;
			end;
		end;
		if viGui.defaultHud.clickArea ~= nil and #viGui.defaultHud.clickArea > 0 then			
			for k,v in pairs(viGui.defaultHud.clickArea) do
				if viGui.defaultHud.clickArea[k] ~= nil then						
					if VehicleInspector:mouseIsInArea(posX, posY, unpack(viGui.defaultHud.clickArea[k]))then
						if button == Input.MOUSE_BUTTON_LEFT and isDown and viGui.defaultHud.clickArea[k].what == "joinVehicle" then
							if viGui.defaultHud.clickArea[k].vehicle.isControlled then
								g_currentMission:showBlinkingWarning("Vehicle is not free", 3500);
								break;
							else
								g_currentMission:requestToEnterVehicle(viGui.defaultHud.clickArea[k].vehicle);								
								if not g_currentMission.guiMenue.on then
									if g_currentMission.vi.frozenAndCursorOverMoh and g_currentMission.vi.foundMoh and g_currentMission.vi.Moh.table ~= nil and g_currentMission.vi.Moh.table.moGeneralSettings ~= nil and viGui.defaultHud.mouseCursorJoinVehicleAutoOff then
										g_currentMission.vi.Moh.table.moGeneralSettings.setMouseCursor = false;										
										g_currentMission.vi.Moh.table.moGeneralSettings.setFrozen = false;
										g_currentMission.vi.isMouseCursor = false;				
										InputBinding.setShowMouseCursor(false);
										if g_currentMission.vi.setFrozen then g_currentMission.vi.isFrozen = false;g_currentMission.isPlayerFrozen = false;end;
									elseif viGui.defaultHud.mouseCursorJoinVehicleAutoOff then
										g_currentMission.vi.isMouseCursor = false;				
										InputBinding.setShowMouseCursor(false);
										if g_currentMission.vi.setFrozen then g_currentMission.vi.isFrozen = false;g_currentMission.isPlayerFrozen = false;end;
									end;
								end;
								break;
							end;
						elseif button == Input.MOUSE_BUTTON_MIDDLE and isDown and viGui.defaultHud.clickArea[k].what == "joinVehicle" then
							local x,y,z = getWorldTranslation(viGui.defaultHud.clickArea[k].vehicle.rootNode);							
							VehicleInspector.hotSpotMap.timer = 0;
							viGui:setGetHotSpotMap(self, false, true, x, z, viGui.defaultHud.clickArea[k].vehicle.viVehicleName);
							g_currentMission:showBlinkingWarning("HotSpot Vehicle at Map", 2000);
						else
							viGui.helpText.posX = posX;
							viGui.helpText.posY = posY;							
							if viGui.defaultHud.clickArea[k].vehicle.isControlled and viGui.defaultHud.clickArea[k].what == "joinVehicle" then 
								if viGui.defaultHud.hotSpot then
									viGui.helpText.txt = tostring("Vehicle is not free\nHotSpot (click middle mouse)");
								else
									viGui.helpText.txt = tostring("Vehicle is not free");
								end;
							elseif viGui.defaultHud.clickArea[k].what == "joinVehicle" then
								if viGui.defaultHud.hotSpot then
									viGui.helpText.txt = tostring("Join Vehicle (click left mouse)\nHotSpot (click middle mouse)");
								else
									viGui.helpText.txt = tostring("Join Vehicle (click left mouse)");
								end;
							else
								viGui.helpText.txt = tostring(viGui.defaultHud.clickArea[k].getTxt);
							end;
							foundHelpText = true;
							break;
						end;
					end;
				end;
			end;			
		end;
	end;
	if viGui.defaultHud.seeAnimals and viGui.defaultHud.clickAreaAnimals ~= nil and #viGui.defaultHud.clickAreaAnimals > 0 then		
			for a=1, table.getn(viGui.defaultHud.clickAreaAnimals) do
				if viGui.defaultHud.clickAreaAnimals[a] ~= nil then
					if VehicleInspector:mouseIsInArea(posX, posY, unpack(viGui.defaultHud.clickAreaAnimals[a])) then						
						if button == Input.MOUSE_BUTTON_LEFT and isDown and not g_currentMission.guiMenue.on then							
							g_gui:showGui("InGameMenu"); 
							g_inGameMenu.pageSelector:setState(g_inGameMenu.pagingElement:getPageMappingIndex(InGameMenu.PAGE_ANIMALS), true);							
						else
							viGui.helpText.posX = posX;
							viGui.helpText.posY = posY;
							viGui.helpText.txt = tostring(viGui.defaultHud.clickAreaAnimals[a].getTxt);
							foundHelpText = true;
							break;
						end;					
					end;
				end;
			end;
		
	end;
	if not foundHelpText then		
		viGui.helpText.txt = "";
		viGui.helpText.posX = 0;
		viGui.helpText.posY = 0;
	end;
end;

function viKeyMouseEvents:setMouseClick(self, whatClick, posX, posY)	
	if whatClick == "hidden" then
		if g_currentMission.vi ~= nil and g_currentMission.vi.isHidden then			
			g_currentMission.vi.isHidden = false;			
			viGui.defaultHud.seeGlobalWarningVehicle = false;
			viGui.defaultHud.seeGlobalWarningVehicleAutoOffIsTimer = 0;			
		elseif g_currentMission.vi ~= nil and not g_currentMission.vi.isHidden then
			g_currentMission.vi.isHidden = true;			
			viGui.defaultHud.seeGlobalWarningVehicle = false;
			viGui.defaultHud.seeGlobalWarningVehicleAutoOffIsTimer = 0;			
		end;
	elseif whatClick == "warnings" then
		if (viGui.defaultHud.seeGlobalWarningIcon and not g_currentMission.vi.isHidden) or (g_currentMission.vi.isHidden and g_currentMission.vi.hiddenWarnings) then
			if viGui.defaultHud.seeGlobalWarningVehicle then
				g_currentMission.vi.isHidden = viGui.defaultHud.seeGlobalWarningVehicleOldHidden;
				viGui.defaultHud.seeGlobalWarningVehicle = false;
				viGui.defaultHud.seeGlobalWarningVehicleAutoOffIsTimer = 0;				
			else
				viGui.defaultHud.seeGlobalWarningVehicleOldHidden = g_currentMission.vi.isHidden;
				g_currentMission.vi.isHidden = true;				
				viGui.defaultHud.seeGlobalWarningVehicle = true;				
			end;
		end;
	elseif whatClick == "settings" then
		if viGui.settingsGuiMenue.on and not viGui.settingsOnViMenue.dragDropPos and not viGui.settingsOnViMenue.isLockDefaultHud then
			if g_currentMission.guiMenue.on and g_currentMission.guiMenue.modMenue == VehicleInspector.modMenue then
				viGui.settingsOnViMenue.dragDropPos = true;
			end;
			--viDragDrop:setPosition(self, posX, posY, true, viGui.settingsOnViMenue.dragDropGround.width, viGui.settingsOnViMenue.dragDropGround.height, "settingsOnViMenue");
		elseif not viGui.settingsOnViMenue.dragDropPos then
			viGui.settingsGuiMenue.on = true;			
			g_currentMission.guiMenue.on = true;
			g_currentMission.guiMenue.modMenue = VehicleInspector.modMenue;
		end;
	elseif whatClick == "onTask" then		
		if viGui.settingsOnViMenue.isTaskOpen then
			viGui.settingsOnViMenue.isTaskOpen = false;
		else
			viGui.settingsOnViMenue.isTaskOpen = true;
		end;
		if #viGui.settingsOnViMenue.taskClickArea <= 0 then
			g_currentMission:showBlinkingWarning("Not Found Taskbar Icons", 1500);
		end;
	end;	
end;
